#!/usr/bin/python

import pygame,math,sys
from pygame.locals import *

# INITIALIZE GAME ENVIRONMENT
pygame.init()
screen = pygame.display.set_mode((640, 480))
pygame.display.set_caption('ScribbleFighter')
black = (0,0,0)
white = (255,255,255)
red = (255,0,0)
clock = pygame.time.Clock()


# INITIALIZE VARIABLES
prevplayerx = playerx = 305
prevplayery = playery = 440
bullets = []
bullet_velocity = 350
ship_velocity = 225
bullet_timeout = 200
last_bullet = 0
facing_left = False
facing_right = False
previous_face = ""
clock = pygame.time.Clock()

# GENERATE ENEMIES
enemies = []
start_enemyx = 25
start_enemyy = 25
interval = 65
enemy_count = 0
number_enemies = 40
for i in range(number_enemies):
	enemies += [[start_enemyx,start_enemyy]]
	start_enemyx += interval
	enemy_count += 1
	if enemy_count == 10:
		enemy_count = 0
		start_enemyy += 50
		start_enemyx = 25


# KEY DICTIONARY
pressed_keys = {}
for key in [K_LEFT, K_RIGHT, K_UP, K_DOWN, K_SPACE, K_ESCAPE]:
	pressed_keys[key] = False


# LOAD GRAPHICS
player = pygame.image.load('player.gif')
player_left = pygame.image.load('left.gif')
player_fullleft = pygame.image.load('fullleft.gif')
player_right = pygame.image.load('right.gif')
player_fullright = pygame.image.load('fullright.gif')
screen.blit(player, (playerx,playery))


# MAIN LOOP
while True:
	# START CLOCK
	time_passed = clock.tick()
	time_passed_secs = time_passed / 1000.0
	
	
	# READ KEY INPUT
	for event in pygame.event.get():
		if not hasattr(event, 'key'): continue
		if event.type == KEYDOWN: 
			pressed_keys[event.key] = True
		if event.type == KEYUP:
			pressed_keys[event.key] = False
	
	if pressed_keys[K_LEFT]:
		playerx += -ship_velocity * time_passed_secs
		facing_left = True
	if pressed_keys[K_RIGHT]:
		playerx += ship_velocity * time_passed_secs
		facing_right = True
		
	if pressed_keys[K_UP]: playery += -ship_velocity * time_passed_secs
	if pressed_keys[K_DOWN]: playery += ship_velocity * time_passed_secs

	if pressed_keys[K_SPACE]:
		if last_bullet > bullet_timeout:
			bullets.append([playerx+5,playery])
			bullets.append([playerx+27,playery])
			#bullets.append([playerx+16,playery-10])
			last_bullet = 0 #last_bullet % bullet_timeout

	if pressed_keys[K_ESCAPE]: sys.exit(0)


	# DRAW SHIP
	screen.fill(black)
	
	if (5 < playerx < 605):
		playerx = playerx
	else:
		playerx = prevplayerx
	if (325 < playery < 450):
		playery = playery
	else:
		playery = prevplayery
	
	if facing_left and not facing_right:
		if previous_face == "left":
			screen.blit(player_fullleft, (playerx,playery))
		else:
			screen.blit(player_left, (playerx,playery))
			previous_face = "left"
	elif facing_right and not facing_left:
		if previous_face == "right":
			screen.blit(player_fullright, (playerx,playery))
		else:
			screen.blit(player_right, (playerx,playery))
			previous_face = "right"
	else:
		screen.blit(player, (playerx,playery))

	facing_left= False
	facing_right = False
	prevplayerx = playerx
	prevplayery = playery
	
	# CREATE BULLETS
	newbullets = []
	newenemies = []
	for bullet in bullets:
		if bullet[1] > 0:
			newbullets.append([bullet[0],bullet[1]-bullet_velocity * time_passed_secs])

	# DRAW ENEMIES
	for enemy in enemies:
		pygame.draw.circle(screen,red,(enemy[0],enemy[1]),15)
		
		
	# DRAW BULLETS
	for bullet in bullets:
		pygame.draw.circle(screen,white,(bullet[0],bullet[1]),3)

	bullets = newbullets
	last_bullet += time_passed

	# UPDATE CANVAS
	screen.blit(SpaceShip.image,(50,50))
	pygame.display.flip()